# Generated by sila2.code_generator; sila2.__version__: 0.10.5
# -----
# This class does not do anything useful at runtime. Its only purpose is to provide type annotations.
# Since sphinx does not support .pyi files (yet?), this is a .py file.
# -----

from __future__ import annotations

from typing import TYPE_CHECKING

if TYPE_CHECKING:
    from typing import Any, Iterable, Optional

    from deviceinfoprovider_types import SetOutputFormat_Responses
    from sila2.client import ClientMetadataInstance, ClientUnobservableProperty


class DeviceInfoProviderClient:
    """

    This SiLA feature provides detailed information about a device, like device name, device type,
    device manufacturer, device product name, device version, device manual, device quick start guide,
    device service manual, device serial number, device registration number, device barcode, device production date,
    device purchase date, device end of warrenty, device service dates, device service information, etc.

    """

    DeviceName: ClientUnobservableProperty[str]
    """
    
            Name of the Device.
        
    """

    DeviceType: ClientUnobservableProperty[str]
    """
    
            Type of the Device.
        
    """

    DeviceManufacturer: ClientUnobservableProperty[str]
    """
    
            Manufacturer of the Device.
        
    """

    DeviceProductName: ClientUnobservableProperty[str]
    """
    
            Product Name of the Device.
        
    """

    DeviceVersion: ClientUnobservableProperty[str]
    """
    
            Version of the Device.
        
    """

    DeviceFirmwareVersion: ClientUnobservableProperty[str]
    """
    
            Version of the Device Firmware.
        
    """

    DeviceManual: ClientUnobservableProperty[str]
    """
    
            URL to Manual of the Device.
        
    """

    DeviceQuickStartGuide: ClientUnobservableProperty[str]
    """
    
            URL to Quick Start Guide of the Device.
        
    """

    DeviceServiceManual: ClientUnobservableProperty[str]
    """
    
            URL to Service Manual of the Device.
        
    """

    HardwareSettings: ClientUnobservableProperty[str]
    """
    
            Hardware Settings of the Device, like serial port settings, etc., preferably in JSON-LD format.
        
    """

    HardwareConfiguration: ClientUnobservableProperty[str]
    """
    
            Hardware Configuration of the Device, like racks with n slots, slot spacing, shakers, barcode reader, CO2 unit, etc., 
            preferably in JSON-LD format.
        
    """

    DeviceInfo: ClientUnobservableProperty[DeviceInfo]
    """
    
            Detailed Information about the Device.
        
    """

    ServiceDates: ClientUnobservableProperty[Any]
    """
    
            Service Dates of the Device.
        
    """

    def SetOutputFormat(
        self, OutputFormat: str, *, metadata: Optional[Iterable[ClientMetadataInstance]] = None
    ) -> SetOutputFormat_Responses:
        """

        Set the output format of the device information, like TEXT, JSON-LD, XML, etc.
        The recommended default output format is JSON-LD, which allows to provide detailed information about the device in a structured way with semantic annotations / context, referencing to defined vocabularies.

        """
        ...
